"use strict";
{
    globalThis.C3.Plugins.EMI_INDO_AppUpdates.Instance = class AppUpdatesInstance extends globalThis.ISDKInstanceBase
    {
        constructor()
        {
            super();

            const properties = this._getInitProperties();


            if (properties)
            {}

            this.EMI_INDO = globalThis.C3.Plugins.EMI_INDO_AppUpdates.Cnds;

            if (typeof cordova == 'undefined')
            {
                return;
            }
         
            this.eventResponse = "";
            this.valuesAvailability = "";
            this.valuesUpdateFlexible = "";
            this.valuesUpdateImmediate = "";

            const self = this;

            this.InAppUpdate = cordova.plugins.InAppUpdate;


            const getUpdateAvailability = () => {

                var onSuccess = function(strSuccess)
                {

                    self.valuesAvailability = (strSuccess);
                    self.eventResponse = (strSuccess)
                    self._trigger(self.EMI_INDO.Ongetupdateavailability);
                };
                var onFailure = function(strError)
                {
                    self.eventResponse = (strError)
                };
                this.InAppUpdate.getUpdateAvailability(onSuccess, onFailure);
            };



            const updateFlexible = () => {
                var onSuccess = function(strSuccess)
                {
                    self.valuesUpdateFlexible = (strSuccess)
                    self.eventResponse = (strSuccess)
                    self._trigger(self.EMI_INDO.Onupdateflexible);
                };
                var onFailure = function(strError)
                {
                    console.warn(strError);
                    self.eventResponse = (strError)
                };
                this.InAppUpdate.updateFlexible(onSuccess, onFailure);
            };

            const updateImmediate = () => {
                var onSuccess = function(strSuccess)
                {
                    self.valuesUpdateImmediate = (strSuccess)
                    self.eventResponse = (strSuccess)
                    self._trigger(self.EMI_INDO.Onupdateimmediate)
                };
                var onFailure = function(strError)
                {
                    console.warn(strError);
                    self.eventResponse = (strError)
                };
                this.InAppUpdate.updateImmediate(onSuccess, onFailure);
            };


            const setSnackbarOptions = (snackbarText, snackbarButton, snackbarButtonColor) => {
                var onSuccess = function(strSuccess)
                {
                    console.log(strSuccess);
                    self.eventResponse = (strSuccess)
                    self._trigger(self.EMI_INDO.Onsetsnackbaroptions);
                };
                var onFailure = function(strError)
                {
                    console.warn(strError);
                    self.eventResponse = (strError)
                };
                var snackbarText = snackbarText;
                var snackbarButton = snackbarButton;
                var snackbarButtonColor = snackbarButtonColor;
                this.InAppUpdate.setSnackbarOptions(onSuccess, onFailure, snackbarText, snackbarButton, snackbarButtonColor);
            };

            this.getUpdateAvailability = getUpdateAvailability;
            this.updateFlexible = updateFlexible;
            this.updateImmediate = updateImmediate;
            this.setSnackbarOptions = setSnackbarOptions;


        }

        _release()
        {
            super._release();
        }

        _saveToJson()
        {
            return {
                // data to be saved for savegames
            };
        }

        _loadFromJson(o)
        {
            // load state for savegames
        }

    };
}